เรื่องเล่าจากการทำ ubuntu do-release-upgrade

มี ubuntu server 18.04.5 ที่มี open source software ชื่อ fogproject เวอร์ชั่นที่ใช้คือ 1.5.8 ซึ่งใช้สำหรับการ cloning Windows ในห้องบริการคอมพิวเตอร์ บางคนคงได้ใช้งานอยู่ และก็มี freeradius 3.0 ติดตั้งไว้ด้วย

อยากจะขยับ ubuntu server จาก 18.04.5 ไปเป็น 20.04 ก็เลยทำคำสั่ง do-release-upgrade ในเครื่องทดสอบ ทำจนเสร็จได้ ubuntu 20.04 สมใจ ในระหว่างขั้นตอนการทำ upgrade นั้นก็จะมีหน้าคำถามว่า จะใช้ไฟล์คอนฟิกของโปรแกรมที่ตรวจพบว่าเรามีการไปแก้ไขไว้ จะเลือกที่ใช้อยู่ปัจจุบัน หรือ จะใช้ของใหม่ตาม package ก็เลือกว่า ใช้ของที่ใช้อยู่ ซึ่งก็ค่อยมาแก้ไขว่า ของใหม่มีอะไรใหม่บ้าง ให้ดูเทียบกับ ไฟล์.dpkg-list

ตอนนี้เราได้ ubuntu 20.04 แล้ว ลองตรวจสอบดูสิว่า fogproject กับ freeradius ใช้งานได้มั้ย เอาหละสิ fogproject รันไม่ขึ้น ลอง reinstall ด้วยคำสั่ง ./installfog.sh -y ก็เจอฟ้องว่า “Stopping web service failed ค้นหาใน google ก็พบคำตอบว่า fogproject รุ่น 1.5.8 ไม่รองรับ ubuntu 20.04 ซึ่งหากใครเจอปัญหาตอนที่ fogproject 1.5.9 ยังไม่ออกมาให้ใช้ –มีหนาวแน่นอน– เพราะมันจะรันไม่ได้เลย ตรงนี้น่ากังวลมาก ๆ และควรระวังมาก ๆ แต่บังเอิญว่า ตอนเวลานี้ fogproject รุ่น 1.5.9 ออกมาเพื่อแก้ปัญหาใช้กับ ubuntu 20.04 ได้แล้ว พร้อมให้ download แล้วที่เว็บไซต์

จะมีปัญหาเกี่ยวกับ php ด้วย คือ มันจะไม่ได้ php7.4 โดยทันที ซึ่งเป็นรุ่นที่มาพร้อมกับ ubuntu 20.04 หากต้องการลงเพิ่มด้วยคำสั่ง apt install php7.4 อันนี้อยากบอกว่า ซอฟต์แวร์ของคุณอาจจะต้องใช้ php เวอร์ชั่นเก่า ก็ควรระมัดระวังด้วย

หลังจากนั้นก็ไปเอา fogproject 1.5.9 มาติดตั้ง จะทำการติดตั้ง php7.4 ให้อัตโนมัติหากยังไม่มี php7.4 ซึ่งก็ทำให้ใช้งาน fogproject ได้ดังเดิม

ต่อมาตรวจสอบ freeradius ก็พบว่ามีการเปลี่ยนเวอร์ชั่นขึ้นเล็กน้อยเช่นกัน และในขั้นตอน upgrade นั้น เราก็เลือกว่าจะใช้ไฟล์คอนฟิกที่เราแก้ไขไว้ ผลคือ ม้นไม่สร้าง symbolic link file ไปยังไดเรกทอรี /etc/freeradius/3.0/sites-enabled ซึ่งจะต้องมี 2 ไฟล์คือ defaults กับ inner-tunnel ซึ่งก็จะสร้างได้ด้วยคำสั่ง ln -s โดยเราต้องสร้างไดเรกทอรีนั้นขึ้นมาก่อน แล้ว cd เข้าไปในไดเรกทอรีนั้น แล้วใช้คำสั่ง ln -s ../sites-available/default default และ ln -s ../sites-available/inner-tunnel inner-tunnel

ตอนนี้ก็ start service freeradius ได้แล้ว

มาลองทดสอบ freeradius user ผ่าน webservice ก็เจอว่า SoapClient error เนื่องจากไม่มี php7.4-soap ก็ติดตั้งด้วยคำสั่ง apt install php7.4-soap ทดสอบอีกทีด้วย username กับ password ของมหาวิทยาลัย ใช้กับ freeradius ได้

(มาเล่าต่อจากเมื่อวาน)

พอจะใช้งาน PXE boot เอ้าเจอปัญหา Windows Client เปิดเครื่องขึ้นมาแล้ว Boot from network ติดต่อกับ server เราไม่ได้ เกิดอะไรขึ้น ก็ไปเช็คดู dhcp server ในเครื่องซิว่าทำงานมั้ย ด้วยคำสั่ง service isc-dhcp-server status ก็โอเค เช็คดู dnsmasq ที่ทำหน้าที่เป็น proxy dhcp ซิ ด้วยคำสั่ง service dnsmasq status มัน error ต้องออกแรงค้นหาอีกแล้ว ก็ไปเจอเรื่องแรก ตอนที่ทำ do-release-upgrade จะมีคำถามว่า ใน ubuntu 20.04 นี้ จะเปลี่ยนเวอร์ชั่นของ LXD ก็มีบรรทัด recommended ก็เลือกตามนั้น แล้วมันก็ส่งผลมามี symbolic link file ใน /etc/dnsmasq.d/lxd ซึ่งชี้ไปยังไฟล์ที่ไม่มีอยู่จริง แสดงว่ามีการเปลี่ยนแปลงอะไรสักอย่างแล้ว ก็ลบไฟล์ lxd นี้ออก ก็ยังรันไม่ได้ ก็กลับไปดูว่าใน server เวอร์ชันก่อนหน้าที่จะทำ do-release-upgrade นั้น ข้างในไฟล์ lxd เขียนไว้ว่าอย่างไร ก็พบว่ามี 2 บรรทัดคือ

bind-interfaces
except-interface=lxdbr0

ผมก็สร้างไฟล์ชื่อ etc.conf ที่มี 2 บรรทัดนั้น แล้วก็ start dnsmasq ด้วยคำสั่ง service dnsmasq start ก็ผ่าน ใช้งานได้

เล่นเอาเหนี่อย เพราะว่า options ชื่อ bind-interfaces ทำให้ dnsmasq ทำงานได้ปรกติ มันมาพร้อม lxd ใน ubuntu 18.04 นั่นเอง แต่ใน ubuntu 20.04 เหมือนว่า lxd จะเปลียนอะไรบางอย่าง จริง ๆ lxd เราก็ไม่ได้ใช้นะ ลบออกได้

(จบส่วนที่มาเพิ่มในวันที่ 2)

จะเห็นได้ว่า การทำ ubuntu do-release-upgrade นั่น อาจเจออะไรแบบที่เล่ามานี้ครับ ขอให้ระมัดระวังกันด้วยนะ

สรุปว่าได้ ubuntu 20.04.1, fogproject1.5.9, php7.4, freeradius 3.0.20

เพจที่บอกว่า fogproject 1.5.8 ไม่รองรับ ubuntu 20.04
https://forums.fogproject.org/topic/14440/stopping-web-service-failed

ขอบคุณครับ

Leave a Reply

This site uses Akismet to reduce spam. Learn how your comment data is processed.